// -------- netfold.h

#ifndef  NETFOLD_H
#define  NETFOLD_H

#include "queue.h"
#include "folder.h"
#include "debug.h"

class Hand;
class EventHandler;

class NetpackFolder : public Folder  {
  EventHandler packet[MAXNETPACK];
  friend class NetpackServer;
public:
  NetpackFolder() : Folder(packet,MAXNETPACK)  { }
  void add_netpack(Hand*,int p,callback);
  void del_netpack(Hand*,int p,callback);
  void reset();
  void dispatch(int, int, int);
};

inline void NetpackFolder::add_netpack(Hand* h,int p,
                                               callback cb)
{
  Assert(p >= 0 && p < MAXNETPACK);
  packet[p].add(h,cb);
}

inline void NetpackFolder::del_netpack(Hand* h,int p,
                                               callback cb)
{
  Assert(p >= 0 && p < MAXNETPACK);
  packet[p].del(h,cb);
}

#endif
